package xyz.etztech.serverapi.commands;

import net.md_5.bungee.api.chat.BaseComponent;
import net.md_5.bungee.api.chat.ComponentBuilder;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import xyz.etztech.serverapi.Color;
import xyz.etztech.serverapi.Lang;
import xyz.etztech.serverapi.ServerAPI;

public class MainCommand implements CommandExecutor {


    ServerAPI plugin;

    public MainCommand(ServerAPI plugin) {
        this.plugin = plugin;
        this.plugin.getCommand("serverapi").setExecutor(this);
    }

    @Override
    public boolean onCommand(CommandSender commandSender, Command command, String s, String[] args) {
        if (!commandSender.hasPermission("serverapi.admin")) {
            Lang.NO_PERMISSION.sms(commandSender);
            return true;
        }
        if (args.length == 0) {
            help(commandSender);
        } else {
            switch (args[0]) {
                case "help":
                    help(commandSender);
                    break;
                case "reload":
                    reload(commandSender);
                    break;
                default:
                    Lang.UNKNOWN_COMMAND.sms(commandSender);
                    break;
            }
        }
        return true;
    }

    private void help(CommandSender commandSender) {
        String version = Bukkit.getPluginManager().getPlugin("ServerAPI").getDescription().getVersion();
        BaseComponent[] message = new ComponentBuilder()
                .append(String.format("===== ServerAPI v%s =====", version)).color(Color.PRIMARY.getChatColor())
                .append("\n/serverapi help - Show this message").color(Color.INFO.getChatColor())
                .append("\n/serverapi reload - Reload the config").color(Color.INFO.getChatColor())
                .create();
        commandSender.spigot().sendMessage(message);
    }

    private void reload(CommandSender commandSender) {
        this.plugin.reloadConfig();
        Lang.PLUGIN_RELOADED.sms(commandSender);
    }

}
